--------------------------------------------------------------------------------
--
-- Euler's Method for a Second Order Differential Equation
--
-- Verification Information:
--
--                  Verified     By whom?           Date         Simulator
--                  --------   ------------        --------     ------------
--  Syntax            yes   Giuseppe Di Guglielmo  15th Feb 09    Modelsim 6.1b
--  Functionality     yes   Giuseppe Di Guglielmo  15th Feb 09    Modelsim 6.1b
--------------------------------------------------------------------------------

use work.type_lib.all;

entity diffeq is
  port( dx_port, a_port, x_port, u_port: in bit8;
		y_port: inout bit8;
  clock, start : in bit );
end diffeq;

architecture diffeq of diffeq is
begin
  process
  variable x, a, y, u, dx, x1, u1, y1 : bit8; begin	
	wait until start'event and start = '1';
	x := x_port; 
	y := y_port; 
	a := a_port;
	u := u_port; 
	dx := dx_port;
	DIFFEQ_LOOP:
	while (x < a) loop
	  wait until clock'event and clock = '1';
	  x1 := x + dx;
	  u1 := u - (3 * x * u * dx) - (3 * y * dx);
	  y1 := y + (u * dx);
	  x := x1; u := u1; y := y1;
	end loop DIFFEQ_LOOP;
	y_port <= y;
  end process; 
end diffeq;

